\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:lnkdlst:> - a Linked List library implementation with persistance
            file storage capabilities.

SYNOPSIS
        void <|destruct|>(<:lnkdlst:> lst);
            Remove <:lnkdlst:> and its contents from memory.
        int  <|construct|>(<:lnkdlst:> *at_lst, ...);
            Constructs a <:lnkdlst:> from a NULL-terminated list of pointers to
            char arrays of size DATA_SIZE.
        int  <|store|>(<:lnkdlst:> lst, const char *filename);
            Store the linked list and its contents to file filename.
        int  <|load|>(<:lnkdlst:> *at_lst, const char *filename);
            Restore contents of <:lnkdlst:> from file filename.

DESCRIPTION
        All the functions in this library either return 0 on success and -1 on
        error, or never fail. If -1 was returned, errno is set.
        The macro <|DATA_SIZE|> defaults to 64) specifies the size of the data
        field of the <:lnkdlst:> in chars. It can be overriden at compilation time.

NOTES
        If you are chaging the <|DATA_SIZE|>, please keep in mind, that the files
        stored with one <|DATA_SIZE|> cannot be read with a library with a different
        DATA_SIZE. Also, it is not guaranteed, that the data in linked list
        files will be valid, if transfered to another system.

EXAMPLES
        <:lnkdlst:> head = NULL;
        char data1[<|DATA_SIZE|>];
        char data2[<|DATA_SIZE|>];
        construct(&head, data1, data2, NULL);
        // ... Fill elements with data ...
        printf("First  element in list:%*s\n", <|DATA_SIZE|>, head->data);
        printf("Second element in list:%*s\n", <|DATA_SIZE|>, head->next->data);

        store(head, "./database.lst");
        destruct(head);
        // ... list completely deallocated, data in elements lost ...

        load(&head, "./database.lst");
        // ... list has completely restored its values ...
        printf("First  element in list:%*s\n", <|DATA_SIZE|>, head->data);
        printf("Second element in list:%*s\n", <|DATA_SIZE|>, head->next->data);

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3
CC=gcc

vpath %.c src

lnkdlst.o:

.PHONY:clean
clean:
	rm -f *.o
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/lnkdlst.h}}
\lstset{language={[ANSI]C}}
\lstset{morekeywords={size_t, va_list, FILE, __attribute__}}
\begin{lstlisting}
#ifndef _LNKDLST_H
#define _LNKDLST_H

// Define section, for compile time changeable options.
#ifndef DATA_SIZE // The size of the buffer, each lnkdlst node has.
#define DATA_SIZE 64
#endif

// Node of lnkdlst.
typedef struct st_lnkdlst
{
    struct st_lnkdlst *next;
    char data[DATA_SIZE];
} *lnkdlst;

// Function declarations.
// All functions return 0 on success and -1 otherwise.
// If -1 was returned, errno may be set to indicate what went wrong.

// Remove lnkdlst and its contents from memory.
void destruct(lnkdlst lst);

// Constructs a lnkdlst from a NULL-terminated list of elements.
// construct(lst, elem1, elem2, ..., NULL);
// (elements are pointers to char arrays of size DATA_SIZE)
int construct(lnkdlst *at_lst, ...)
    __attribute__((sentinel));

// Store the linked list and its contents to file filename.
int store(lnkdlst lst, const char *filename);

// Restore contents of lnkdlst from file filename.
int load(lnkdlst *at_lst, const char *filename);
#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/lnkdlst.c}}
\begin{lstlisting}
#include <errno.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "lnkdlst.h"

void destruct(lnkdlst lst)
{
    lnkdlst run;
    while (lst)
    {
        run = lst->next;
        free(lst);
        lst = run;
    }
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
int construct(lnkdlst *at_lst, ...)
{
    if (!at_lst || *at_lst)
    {
        errno = EINVAL;
        return -1; // E: at_lst should be a pointer to an empty lnkdlst.
    }

    // Allocate head of the list.
    lnkdlst run = *at_lst = malloc(sizeof(struct st_lnkdlst));
    if (!run)
        return -1; // E: malloc failed.

    va_list elements;
    va_start(elements, at_lst);
    char *elem;
    while ((elem = va_arg(elements, char *)))
    {
        run = run->next = malloc(sizeof(struct st_lnkdlst));
        if (!run)
        {
            va_end(elements);
            return -1; // E: malloc failed.
        }
        memcpy(&run->data, elem, sizeof(run->data));
    }
    va_end(elements);
    return 0;
}

int store(lnkdlst lst, const char *filename)
{
    // Open the file.
    FILE *fp;
    if (!(fp = fopen(filename, "w")))
        return -1; // E: fopen failed.

    // The first entry in the file is the size of data blocks.
    size_t data_size = sizeof(lst->data);
    fwrite(&data_size, sizeof(size_t), 1, fp);

    // Write the data contents to file sequentially.
    while (lst)
    {
        if (!fwrite(lst->data, data_size, 1, fp))
        {
            if (errno == EINTR)
                continue;
            return -1; // E: fwrite failed.
        }
        lst = lst->next;
    }

    fflush(fp);
    fclose(fp);
    return 0;
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
int load(lnkdlst *at_lst, const char *filename)
{
    if (!at_lst || *at_lst)
    {
        errno = EINVAL;
        return -1; // E: at_lst should be a pointer to an empty lnkdlst.
    }

    // Allocate head of the list.
    lnkdlst run = *at_lst = malloc(sizeof(struct st_lnkdlst));
    if (!run)
        return -1; // E: malloc failed.

    // Open the file.
    FILE *fp;
    if (!(fp = fopen(filename, "r")))
        return -1; // E: fopen failed.

    // The first entry in the file is the size of data blocks.
    size_t data_size;
    while (!fread(&data_size, sizeof(size_t), 1, fp))
    {
        if (errno == EINTR)
            continue;
        return -1; // E: fread failed.
    }

    // If it doesn't match the current size, something went wrong.
    if (data_size != sizeof(run->data))
    {
        errno = ERANGE;
        return -1; // E: DATA_SIZE is wrong.
    }

    // Read lnkdlst nodes from file.
    while (1)
    {
        while (!fread(&run->data, data_size, 1, fp))
        {
            if (errno == EINTR)
                continue;
            return -1; // E: fread failed.
        }

        if (feof(fp))
            break;

        run = run->next = malloc(sizeof(struct st_lnkdlst));
        if (!run)
            return -1; // E: malloc failed.
    }

    fclose(fp);
    return 0;
}
\end{lstlisting}
\end{document}
